#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int ll

const int INF = (int)1e15;

struct segtree {
    int size;
    vector<int> tree;
    segtree(int n) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.assign(2 * size - 1, INF);
    }
    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            set(i, v, 2 * x + 1, lx, m);
        } else {
            set(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }
    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }
    int get(int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {
            return INF;
        }
        if (lx >= l && r >= rx) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        int s1 = get(l, r, 2 * x + 1, lx, m);
        int s2 = get(l, r, 2 * x + 2, m, rx);
        return min(s1, s2);
    }
    int get(int l, int r) {
        return get(l, r, 0, 0, size);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n), pref(n + 1);
    segtree st(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st.set(i, a[i]);
        pref[i + 1] = pref[i] + a[i];
    }
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        // int t = i;
        // int l = i, r = n;
        // while (l + 1 < r) {
        //     int mid = (l + r) / 2;
        //     if (t + n - mid >= k) {
        //         l = mid;
        //     } else {
        //         r = mid;
        //     }
        // }
        // if (t + n - l > k) {
        //     break;
        // }
        for (int j = i + 1; j < n; j++) {
            if (i + n - j < k) {
                break;
            }
            ans = max(ans, pref[j + 1] - pref[i] - min(st.get(0, i), st.get(j + 1, n)));
        }
        // ans = max(ans, pref[l + 1] - pref[i] - min(st.get(0, i), st.get(l + 1, n)));
    }
    cout << ans << '\n';
    // int tt = ans;
    // for (int i = 0; i < n; i++) {
    //     for (int j = i + 1; j < n; j++) {
    //         if (k == k) {
    //             int t = max({pref[j + 1] - pref[i], pref[i + 1], pref[n] - pref[j]});
    //             int K = min({pref[j + 1] - pref[i], pref[i + 1], pref[n] - pref[j]});
    //             ans = max(ans, t - K);
    //         }
    //     }
    // }
    // cout << ans << '\n';
    // cout << endl;
    // if (ans != tt) {
    //     cout << tt << ' ' << ans;
    //     for (auto u : a) {
    //         cout << u << ' ';
    //     }
    //     exit(0);
    // }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
