#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int ll

const int INF = (int)1e15;

struct segtree {
    int size;
    vector<int> tree;
    segtree(int n) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.assign(2 * size - 1, INF);
    }
    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            set(i, v, 2 * x + 1, lx, m);
        } else {
            set(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }
    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }
    int get(int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {
            return INF;
        }
        if (lx >= l && r >= rx) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        int s1 = get(l, r, 2 * x + 1, lx, m);
        int s2 = get(l, r, 2 * x + 2, m, rx);
        return min(s1, s2);
    }
    int get(int l, int r) {
        return get(l, r, 0, 0, size);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n), pref(n + 1);
    segtree st(n);
    vector<int> in;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] == 0) {
            in.push_back(i);
        }
        st.set(i, a[i]);
        pref[i + 1] = pref[i] + a[i];
    }
    ll ans = 0;
    if (k == 3) {
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (j + 1 < n) {
                    int t = max({pref[i], pref[j + 1] - pref[i + 1], pref[n] - pref[j + 1]});
                    int K = min({pref[i], pref[j + 1] - pref[i + 1], pref[n] - pref[j + 1]});
                    ans = max(ans, 1LL * (t - K));
                }
            }
        }
    } else if (k == 2) {
        ans = max(pref[n - 1] - a[n - 1], pref[n] - pref[1] - a[0]);
    } else if  (n <= 15) {
        for (int mask = 0; mask < (1 << n); mask++) {
            if (__builtin_popcount(mask) != k) {
                continue;
            }
            if (!(mask & (1 << (n - 1)))) {
                continue;
            }
            bitset<6> K(mask);
            // cout << K << '\n';
            multiset<int> s;
            int sum = a[0];
            for (int i = 0; i < n; i++) {
                sum += a[i];
                if (mask & (1 << i)) {
                    s.insert(sum);
                    sum = 0;
                }
            }
            ans = max(ans, *s.rbegin() - *s.begin());
        }
    }
    cout << ans << '\n';
    // ans = max(pref[n - 1] - a[n - 1], pref[n] - pref[1] - a[0]);
    // cout << ans << '\n';
    // cout << max(pref[n - 1] - a[n - 1], pref[n] - pref[1] - a[0]);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}